package audiotesting;

/**
 * Clase encargada de obtner la salida de audio del programa
 */

import be.hogent.tarsos.dsp.AudioDispatcher;
import be.hogent.tarsos.dsp.AudioPlayer;
import be.hogent.tarsos.dsp.WaveformWriter;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.sound.sampled.LineUnavailableException;

public class AudioSalida implements InSignal {
   
    private OutSignal conectado;
    private Simulator sim;
    private AudioDispatcher dispatcher;
   
    /**
     * Constructor, recive como paraemtro la simulacion
     * @param s 
     */
    public AudioSalida (Simulator s) {
      sim = s;
      conectado = null;
      sim.addSalida(this);
   }
   
   public void removeFromSource(OutSignal output){
       conectado = null;
   }
   
   public void addSource(OutSignal output) {
       conectado = output;
   }
   
   public void disconnectInput(){
       conectado = null;
   }

   public void connectInput(OutSignal output){
        conectado = output;
        output.connectDrain(this);
        
   }
   
   public void inputValueChanged() {
       dispatcher = conectado.getDispatcher();
       
   }
   
   /**
    * Metodo encargado de revisar si tiene conectado entradas
    * @return 
    */
   public boolean hasConnectedDrains() {
    return !(conectado==null);
   }
   
   /**
    * Metodo encargado de escuchar al audio entregado a la salida
    */
   public void escuchar(){
       try {
           dispatcher.addAudioProcessor(new WaveformWriter(dispatcher.getFormat(), "Salida.wav"));
           dispatcher.addAudioProcessor(new AudioPlayer(sim.getFormat()));
       } catch (LineUnavailableException ex) {
           Logger.getLogger(AudioSalida.class.getName()).log(Level.SEVERE, null, ex);
       }
       Thread t = new Thread(dispatcher);
       t.start();
   }
   
}
