package audiotesting;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.border.Border;
import javax.swing.border.LineBorder;



/**
 * Clase encargada de ejecutar el programa, setear los paneles correspondientes y sus eventos asciasdos
 * para una correcta simulacion de un circuito de sonido
 * @author Daniel Cardenas
 * @author Luis Muñoz
 * @author Roberto Muñoz
 */
public class AudioTesting {

    public static void main(String[] args) {
        AudioTestingFrame circuitFrame = new AudioTestingFrame();
        circuitFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        ImageIcon projecticon = new ImageIcon("./Images/icono.gif");
        circuitFrame.setIconImage(projecticon.getImage());
        circuitFrame.setVisible(true);
    }
}
class AudioTestingFrame extends JFrame {
   public static final int DEFAULT_WIDTH=3*640/2;
   public static final int DEFAULT_HEIGHT=3*480/2;
   public static int connection_state=0;
   
   MouseListener mListener;
   MouseListener2 mListener2;
   
   /**/Dimension labPanelsize = new Dimension(2*DEFAULT_WIDTH/3, DEFAULT_HEIGHT);
       Dimension labPanel2size = new Dimension(DEFAULT_WIDTH/3+50, 2*DEFAULT_HEIGHT/3);
       Dimension labPanel3size = new Dimension(DEFAULT_WIDTH/3+50, 1*DEFAULT_HEIGHT/3);
       
	public AudioTestingFrame() {
		
                //de la ventana
                setTitle("AudioTesting");
		setSize(DEFAULT_WIDTH+50, DEFAULT_HEIGHT);
                SoundCircuit circuit = new SoundCircuit();
                
                SoundCircuit circuit2 = new SoundCircuit();

                JPanel labPanel = new SoundCircuitLabPanel(circuit);
                JPanel labPanel2a = new SoundCircuitLabPanel(circuit2);
                
                PanelControl labPanel3 = new PanelControl();
                JPanel labPanelasdasd = new JPanel();
                labPanelasdasd.add(new JLabel("OLI",JLabel.CENTER));
                labPanel.setBackground(Color.LIGHT_GRAY);
                labPanel.setFocusable(true);
                labPanel2a.setBackground(Color.WHITE);
                //labPanel3.setBackground(Color.WHITE);  
                    
                //Separacion de paneles
                JSplitPane splitPane0 = new JSplitPane(JSplitPane.VERTICAL_SPLIT,labPanel2a, labPanel3);
                splitPane0.setOneTouchExpandable(false);
                splitPane0.setDividerSize(1);
                splitPane0.setDividerLocation(2*DEFAULT_HEIGHT/3);
                JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,labPanel,splitPane0);
                splitPane.setOneTouchExpandable(false);
                splitPane.setDividerSize(5);
                splitPane.setDividerLocation(2*DEFAULT_WIDTH/3);
                add(splitPane);
                
                //Tamaño de los paneles
                labPanel.setMinimumSize(labPanelsize);
                labPanel2a.setMinimumSize(labPanel2size);
                labPanel3.setMinimumSize(labPanel3size);

		circuit.setPanel(labPanel);   // to repaint view when model changes
        	circuit2.setPanel(labPanel2a);   // to repaint view when model changes
                
                JMenuBar menuBar = createLabMenuBar(circuit);
                
                //Componiendo el panel para agregar los bloques
                GridLayout gridl = new GridLayout(3,1);
                circuit2.getpanel().setLayout(gridl);
                Border border = LineBorder.createGrayLineBorder();
                JLabel label1 = new JLabel("-----Input/Ouput-----",JLabel.CENTER);
                label1.setBorder(border);
                label1.setVerticalAlignment(WIDTH);
                circuit2.getpanel().add(label1, BorderLayout.CENTER);            
                JLabel label2 = new JLabel("----Filters----",JLabel.CENTER);
                label2.setBorder(border);
                label2.setVerticalAlignment(WIDTH);
                circuit2.getpanel().add(label2);
                JLabel label3 = new JLabel("----Effects----",JLabel.CENTER);
                label3.setBorder(border);
                label3.setVerticalAlignment(WIDTH);
                circuit2.getpanel().add(label3);
                circuit2.addOutSound(40,40);
                circuit2.addAudio(180, 40);                      
                circuit2.addFiltroPasabajo(20,200);
                circuit2.addFiltroPasaalto(200,200);
                circuit2.addFiltroPasabanda(20, 260);             
                circuit2.addFlanger(20,350);
                circuit2.addDelay(200,350);              
                circuit2.addWire(130,440);            
                
                setJMenuBar(menuBar);
                
                //Listener
                mListener = new MouseListener(circuit, labPanel,labPanel3);
                addKeyListener(mListener);
                
                labPanel.addMouseListener(mListener);
                labPanel.addMouseMotionListener(mListener);
                labPanel.addMouseWheelListener(mListener);
                
                mListener2 = new MouseListener2(circuit, circuit2, labPanel2a);/**/
                labPanel2a.addMouseListener(mListener2);
                labPanel2a.addMouseMotionListener(mListener2);
                labPanel2a.addMouseWheelListener(mListener2);
                
    }

        
    private JMenuBar createLabMenuBar(SoundCircuit circuit) {
		EditMenuListener editListener = new EditMenuListener(circuit);
		SimulateMenuListener simulateListener = new SimulateMenuListener(circuit);

		JMenuBar mb = new JMenuBar();
 
		JMenu menu = new JMenu("Simulate");
		mb.add(menu);
		JMenuItem menuItem = new JMenuItem("Start");
		menuItem.addActionListener(simulateListener);
		menu.add(menuItem);
                menuItem = new JMenuItem("Escuchar");
		menuItem.addActionListener(editListener);
		menu.add(menuItem);
                menuItem = new JMenuItem("Cerrar");
		menuItem.addActionListener(editListener);
		menu.add(menuItem);
		return mb;          
	}   
        
}