package audiotesting;

import java.awt.Graphics2D;
import java.awt.*;
import java.awt.image.BufferedImage;

public interface Drawable {
    /**
     * Metodo encargado de dibujar
     * @param g2d 
     */
   void draw (Graphics2D g2d);
   /**
    * Metodo encargado de verificar si el punto se encuentra sobre la posicion de un drawable
    * @param p
    * @return 
    */
   boolean contains (Point p);
   /**
    * Metodo encargado de redibujar
    * @param dx
    * @param dy 
    */
   void dragIn(int dx, int dy);
   /**
    * Metodo encargado de dar vuelta el dibujo
    */
   void flip();
   /**
    * Metodo encarddo se setear el estado del dibujo cuando el cursor este sobre este.
    */
   void setSelected();
   /**
    * Metodo encarddo se setear el estado del dibujo cuando el cursor no este sobre este.
    */
   void setReleased(); 
   /**
    * Metodo encargado de remover el dibujo
    */
   void removeDraw();
   /**
    * Metodo encargado de retornar el bloque correspondiente al dibujo
    * @return 
    */
   Bloque getBloque();
   /**
    * Metodo encargado de retornar el entorno grafico de la entrada del dibujo
    * @return 
    */
   Shape getGInput();
   /**
    * Metodo encargado de retornar el entorno grafico de la salida del dibujo
    * @return 
    */
   Shape getGOutput();
   
   /**
    * Metodo encargado de retornar la imagen correspondiente al bloque
    * @return 
    */
   void openimage();
}