package audiotesting;

import java.awt.Point;
import javax.swing.JPanel;
import java.awt.event.*;
import java.awt.event.MouseAdapter;

/**
 *Clase asociada a manejar los eventos del mouse y teclado asociado a la ventana del circuito de sonido
 */
public class MouseListener extends MouseAdapter implements KeyListener{
   private SoundCircuit circuit;
   private Drawable currentComponent;
   private Drawable FirstComponent;
   private Drawable SecondComponent;
   private GWire ConnectorComponent;
   private JPanel panel;
   private PanelControl panelcontrol;
   private Point last, current;
   private static int a;
   
   /**
    * Constructor
    * @param c
    * @param p
    * @param p3 
    */
   public MouseListener (SoundCircuit c, JPanel p, PanelControl p3){
      circuit = c;
      panel = p;
      last = current = null;
      panelcontrol = p3;
      panel.addKeyListener(this);
   } 
   
    public void mouseMoved(MouseEvent e) {
        last = e.getPoint();
        Drawable newComponent = circuit.find(last);
        if (newComponent == currentComponent) return;
        if (currentComponent != null) {
            currentComponent.setReleased();
            currentComponent = null;
        }

        if (newComponent != null) { 
            currentComponent = newComponent;
            if(currentComponent.getBloque()!=null)
                if(currentComponent.getBloque().getPanel()!=null){
                    panelcontrol.setPanel(currentComponent.getBloque().getPanel());
                    panelcontrol.showActualPanel();
                }
            currentComponent.setSelected();
        }
        panel.repaint();
   }
   
   public void mouseDragged(MouseEvent e) {
        if (currentComponent == null) 
            return;
        current = e.getPoint();
        currentComponent.dragIn(current.x-last.x, current.y-last.y);
        KeyListener[] listakey = panel.getKeyListeners();
        last=current;
        panel.repaint();
   }
   
    public void mouseWheelMoved(MouseWheelEvent e) {
        if (currentComponent == null) return;
        currentComponent.flip();
        panel.repaint();
    }
   
    public void mouseReleased(MouseEvent e) {   
        if (currentComponent == null) 
        AudioTestingFrame.connection_state=0;
       
       if (currentComponent != null && !(currentComponent instanceof GWire) &&  AudioTestingFrame.connection_state==1 && (currentComponent instanceof OutSignal) ){
           AudioTestingFrame.connection_state=2; 
           FirstComponent = currentComponent;
           panel.repaint();
           return; 
       }// se tiene primera componente}
       
       if (currentComponent != null && !(currentComponent instanceof GWire) &&  AudioTestingFrame.connection_state == 2 && (currentComponent instanceof InSignal) ){
            AudioTestingFrame.connection_state=0;
            ConnectorComponent = circuit.addWire(200f,200f);
            SecondComponent = currentComponent;
            ConnectorComponent.dragIn2((int)FirstComponent.getGOutput().getBounds2D().getCenterX()- (int)ConnectorComponent.getGInput().getBounds2D().getCenterX(), 
                                      (int)FirstComponent.getGOutput().getBounds2D().getCenterY()- (int)ConnectorComponent.getGInput().getBounds2D().getCenterY(),
                                      (int)SecondComponent.getGInput().getBounds2D().getCenterX()- (int)ConnectorComponent.getGOutput().getBounds2D().getCenterX(),
                                      (int)SecondComponent.getGInput().getBounds2D().getCenterY()- (int)ConnectorComponent.getGOutput().getBounds2D().getCenterY());
            ConnectorComponent.tryToConnect2();
            panel.repaint();
        }// se realiza coneccion 
       
        if (currentComponent instanceof GWire) {
            GWire w = (GWire)currentComponent;
            w.setReleased();
            w.tryToConnect();         
            panel.repaint();
        }
    }

    public void keyTyped(KeyEvent ke) {  
    }

    public void keyPressed(KeyEvent ke) {
        if (currentComponent == null) return;
        if(ke.getKeyChar()=='d' || ke.getKeyChar()=='D'){
            currentComponent.removeDraw();
            circuit.deleteSource(currentComponent);
            panelcontrol.setBlankPanel();
            panel.repaint();
        }
    }

    public void keyReleased(KeyEvent ke) {
    }
    
}