package audiotesting;

import java.awt.Dimension;
import java.awt.GridLayout;
import javax.swing.*;
import javax.swing.event.ChangeListener;
/**
 *Clase encargada de crear el panel asociado al efecto Flangeer
 */
public class PFlanger extends JPanel{
    
    private Flanger Flangerblock;
    static final int FPS_MIN = 0;
    static final int FPS_MAX = 30;
    static final int FPS_INIT = 15;
    private JLabel title;
    private JSlider impactslider;
    private JSlider frequencyslider;
    private JSlider gainslider;
    private JLabel frequencylabel;
    private JLabel impactlabel;
    private JLabel gainlabel;
    
    public PFlanger(Flanger Flanger_in){
        Flangerblock = Flanger_in;
        Dimension panelD = new Dimension(3*640/6,3*480/9); 
        setPreferredSize(panelD);
        frequencyslider = new JSlider(JSlider.HORIZONTAL,1, 100, 10);
        impactslider = new JSlider(JSlider.HORIZONTAL,1, 100, 50);
        gainslider = new JSlider(JSlider.HORIZONTAL,1, 200, 100);
        title = new JLabel("EFECTO FLANGER", JLabel.CENTER);
        frequencylabel = new JLabel("Frequency", JLabel.CENTER);
        impactlabel = new JLabel("Impact", JLabel.CENTER);
        gainlabel = new JLabel("Ganancia", JLabel.CENTER);

        //Listeners
        gainslider.addChangeListener(new ChangeListener() {
			public void stateChanged(javax.swing.event.ChangeEvent arg0) {
				if (Flangerblock != null) {
					int gainValue = gainslider.getValue();
					Flangerblock.setGain(gainValue);
				}
			}
		});
        impactslider.addChangeListener(new ChangeListener() {
			public void stateChanged(javax.swing.event.ChangeEvent arg0) {
				if (Flangerblock != null) {
					int echoValue = impactslider.getValue();
					Flangerblock.setImpact(echoValue);
				}
			}
		});
        frequencyslider.addChangeListener(new ChangeListener() {
			public void stateChanged(javax.swing.event.ChangeEvent arg0) {
				if (Flangerblock != null) {
					int decayValue = frequencyslider.getValue();
					Flangerblock.setFrequency(decayValue);
				}
			}
		});
        
     
        setLayout(new GridLayout(4,2));
        add(title);
        add(new JLabel("ID: #"+Flangerblock.getDescription().split("_")[1], JLabel.CENTER));
        add(frequencylabel);
        Dimension d3 = frequencyslider.getPreferredSize();  
        frequencyslider.setPreferredSize(new Dimension(d3.width-50,d3.height));
        add(frequencyslider);
        add(impactlabel);
        Dimension d2 = impactslider.getPreferredSize();  
        impactslider.setPreferredSize(new Dimension(d2.width-50,d2.height));
        add(impactslider);
        add(gainlabel);
        Dimension d = gainslider.getPreferredSize();  
        gainslider.setPreferredSize(new Dimension(d.width-50,d.height));
        add(gainslider);
    }
}
