package audiotesting;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.util.Hashtable;
import javax.swing.*;
import javax.swing.event.ChangeListener;
/**
 *Clase encargada de crear el panel asociado al Filtro Pasa Bajo
 */
public class PPasabajo extends JPanel{
    
    private FiltroPasabajo Filterrblock;
    private JLabel title;
    private JSlider freqslider;;
    private JLabel freqlabel;

    
    public PPasabajo(FiltroPasabajo Filtro_in){
        Filterrblock = Filtro_in;
        Dimension panelD = new Dimension(3*640/6,3*480/9); 
        setPreferredSize(panelD);
        freqslider = new JSlider(JSlider.HORIZONTAL,1, 12000, 4000);
        Hashtable labelTable = new Hashtable();
        labelTable.put( new Integer( 0 ), new JLabel("Stop") );
        labelTable.put( new Integer( 12000 ), new JLabel("12000") );
        labelTable.put( new Integer( 1 ), new JLabel("1") );
        freqslider.setLabelTable( labelTable );
        freqslider.setMajorTickSpacing(1000);
        freqslider.setPaintTicks(true);
        freqslider.setPaintLabels(true);
        title = new JLabel("FILTRO PASABAJO", JLabel.CENTER);
        freqlabel = new JLabel("Freq. Corte [Hz]", JLabel.CENTER);


        //Listeners
        freqslider.addChangeListener(new ChangeListener() {
			public void stateChanged(javax.swing.event.ChangeEvent arg0) {
				if (Filterrblock != null) {
					int freq = freqslider.getValue();
					Filterrblock.setFreqCorte(freq);
				}
			}
		});
      
        setLayout(new GridLayout(2,2));
        add(title);
        add(new JLabel("ID: #"+Filterrblock.getDescription().split("_")[1], JLabel.CENTER));
        add(freqlabel);
        Dimension d3 = freqslider.getPreferredSize();  
        freqslider.setPreferredSize(new Dimension(d3.width-50,d3.height));
        add(freqslider);

    }
}
