package audiotesting;

import java.util.*;
import javax.sound.sampled.AudioFormat;

/**
 * Metodo encargado de la simulacion del circuito
 */
public class Simulator {
    
    private AudioSalida salidas;
    private ArrayList<Bloque> BloqueList;
    private AudioEntrada Entrada;
    
    /**
     * Constructor
     */
    public Simulator (){
        salidas = null;
        BloqueList = new ArrayList<>();
    }
    
    /**
     * Agrega la salida de audio del circuito
     * @param salida 
     */
    public void addSalida(AudioSalida salida) {
        salidas = salida;
    }
    
    /**
     * Agrega la entrada de audio del circuito
     * @param ae 
     */
    public void addEntrada(AudioEntrada ae) {
        Entrada = ae;
        //dispatcher = Entrada.getDispatcher();
    }
    
    /**
     * Simula el circuito
     */
    public void simulate() {
        Entrada.restart();
        Entrada.propagateOutputValue();
    }
    
    /**
     * Escucha el audio de la salida
     */
     public void escuchar(){
       salidas.escuchar();
    }
    
     /**
      * Obtiene el formato del audio
      * @return 
      */
    public AudioFormat getFormat(){
        return Entrada.getFormat();
    }
   
}
